//
//  eval.hpp
//  fornax3
//
//  Created by Anders on 28/12/2020.
//

#ifndef eval_hpp
#define eval_hpp

#include <stdint.h>
#include "board.h"
#include "bits.h"
#include "eval_defs.h"
#include "eval_piecetables.h"
#include "eval_debug_print.hpp"

eval eval_calculate_contempt(const Board* board);
void eval_set_contempt_factor(long contempt);
eval eval_count_psqt(const Side *side, const piecetable *psqt);
uint8_t eval_count_phase(const Side* side);
eval eval_count_material(const Side* side);
uint8_t eval_get_phase(const Board* board);
eval eval_evaluate(const Board* board);
eval eval_evaluate_debug(const Board* board);


#endif /* eval_hpp */
